## btrfs-tools 3.12

=== Makefile ===
# Export all variables to sub-makes by default
export

CC = gcc
LN = ln
AR = ar
AM_CFLAGS = -Wall -D_FILE_OFFSET_BITS=64 -DBTRFS_FLAT_INCLUDES -fno-strict-aliasing -fPIC
CFLAGS = -g -O1 -fno-strict-aliasing
objects = ctree.o disk-io.o radix-tree.o extent-tree.o print-tree.o \
	  root-tree.o dir-item.o file-item.o inode-item.o inode-map.o \
	  extent-cache.o extent_io.o volumes.o utils.o repair.o \
	  qgroup.o raid6.o free-space-cache.o list_sort.o
cmds_objects = cmds-subvolume.o cmds-filesystem.o cmds-device.o cmds-scrub.o \
	       cmds-inspect.o cmds-balance.o cmds-send.o cmds-receive.o \
	       cmds-quota.o cmds-qgroup.o cmds-replace.o cmds-check.o \
	       cmds-restore.o cmds-rescue.o chunk-recover.o super-recover.o
libbtrfs_objects = send-stream.o send-utils.o rbtree.o btrfs-list.o crc32c.o \
		   uuid-tree.o
libbtrfs_headers = send-stream.h send-utils.h send.h rbtree.h btrfs-list.h \
	       crc32c.h list.h kerncompat.h radix-tree.h extent-cache.h \
	       extent_io.h ioctl.h ctree.h btrfsck.h
TESTS = fsck-tests.sh

INSTALL = install
prefix ?= /usr/local
bindir = $(prefix)/bin
lib_LIBS = -luuid -lblkid -lm -lz -llzo2 -L.
libdir ?= $(prefix)/lib
incdir = $(prefix)/include/btrfs
LIBS = $(lib_LIBS) $(libs_static)

ifeq ("$(origin V)", "command line")
  BUILD_VERBOSE = $(V)
endif
ifndef BUILD_VERBOSE
  BUILD_VERBOSE = 0
endif

ifeq ($(BUILD_VERBOSE),1)
  Q =
else
  Q = @
endif

MAKEOPTS = --no-print-directory Q=$(Q)

progs = mkfs.btrfs btrfs-debug-tree btrfsck \
	btrfs btrfs-map-logical btrfs-image btrfs-zero-log btrfs-convert \
	btrfs-find-root btrfstune btrfs-show-super

# external libs required by various binaries; for btrfs-foo,
# specify btrfs_foo_libs = <list of libs>; see $($(subst...)) rules below
btrfs_convert_libs = -lext2fs -lcom_err
btrfs_image_libs = -lpthread
btrfs_fragment_libs = -lgd -lpng -ljpeg -lfreetype

SUBDIRS = man
BUILDDIRS = $(patsubst %,build-%,$(SUBDIRS))
INSTALLDIRS = $(patsubst %,install-%,$(SUBDIRS))
CLEANDIRS = $(patsubst %,clean-%,$(SUBDIRS))

.PHONY: $(SUBDIRS)
.PHONY: $(BUILDDIRS)
.PHONY: $(INSTALLDIRS)
.PHONY: $(TESTDIRS)
.PHONY: $(CLEANDIRS)
.PHONY: all install clean

# Create all the static targets
static_objects = $(patsubst %.o, %.static.o, $(objects))
static_cmds_objects = $(patsubst %.o, %.static.o, $(cmds_objects))
static_libbtrfs_objects = $(patsubst %.o, %.static.o, $(libbtrfs_objects))

# Define static compilation flags
STATIC_CFLAGS = $(CFLAGS) -ffunction-sections -fdata-sections
STATIC_LDFLAGS = -static -Wl,--gc-sections
STATIC_LIBS = $(lib_LIBS) -lpthread

libs_shared = libbtrfs.so.0.1
libs_static = libbtrfs.a
libs = $(libs_shared) $(libs_static)
lib_links = libbtrfs.so.0 libbtrfs.so
headers = $(libbtrfs_headers)

# make C=1 to enable sparse
check_defs := .cc-defines.h 
ifdef C
	#
	# We're trying to use sparse against glibc headers which go wild
	# trying to use internal compiler macros to test features.  We
	# copy gcc's and give them to sparse.  But not __SIZE_TYPE__
	# 'cause sparse defines that one.
	#
	dummy := $(shell $(CC) -dM -E -x c - < /dev/null | \
			grep -v __SIZE_TYPE__ > $(check_defs))
	check = sparse -include $(check_defs) -D__CHECKER__ \
		-D__CHECK_ENDIAN__ -Wbitwise -Wuninitialized -Wshadow -Wundef
	check_echo = echo
	# don't use FORTIFY with sparse because glibc with FORTIFY can
	# generate so many sparse errors that sparse stops parsing,
	# which masks real errors that we want to see.
else
	check = true
	check_echo = true
	AM_CFLAGS += -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2
endif

%.o.d: %.c
	$(Q)$(CC) -MM -MG -MF $@ -MT $(@:.o.d=.o) -MT $(@:.o.d=.static.o) -MT $@ $(AM_CFLAGS) $(CFLAGS) $<

.c.o:
	@$(check_echo) "    [SP]     $<"
	$(Q)$(check) $(AM_CFLAGS) $(CFLAGS) $<
	@echo "    [CC]     $@"
	$(Q)$(CC) $(AM_CFLAGS) $(CFLAGS) -c $<

%.static.o: %.c
	@echo "    [CC]     $@"
	$(Q)$(CC) $(AM_CFLAGS) $(STATIC_CFLAGS) -c $< -o $@

all: $(progs) manpages $(BUILDDIRS)
$(SUBDIRS): $(BUILDDIRS)
$(BUILDDIRS):
	@echo "Making all in $(patsubst build-%,%,$@)"
	$(Q)$(MAKE) $(MAKEOPTS) -C $(patsubst build-%,%,$@)

test:
	$(Q)for t in $(TESTS); do \
		echo "     [TEST]    $$t"; \
		bash tests/$$t || exit 1; \
	done

#
# NOTE: For static compiles, you need to have all the required libs
# 	static equivalent available
#
static: btrfs.static mkfs.btrfs.static btrfs-find-root.static

version.h:
	@echo "    [SH]     $@"
	$(Q)bash version.sh

$(libs_shared): $(libbtrfs_objects) $(lib_links) send.h
	@echo "    [LD]     $@"
	$(Q)$(CC) $(CFLAGS) $(libbtrfs_objects) $(LDFLAGS) $(lib_LIBS) \
		-shared -Wl,-soname,libbtrfs.so.0 -o libbtrfs.so.0.1

$(libs_static): $(libbtrfs_objects)
	@echo "    [AR]     $@"
	$(Q)$(AR) cru libbtrfs.a $(libbtrfs_objects)

$(lib_links):
	@echo "    [LN]     $@"
	$(Q)$(LN) -sf libbtrfs.so.0.1 libbtrfs.so.0
	$(Q)$(LN) -sf libbtrfs.so.0.1 libbtrfs.so

# keep intermediate files from the below implicit rules around
.PRECIOUS: $(addsuffix .o,$(progs))

# Make any btrfs-foo out of btrfs-foo.o, with appropriate libs.
# The $($(subst...)) bits below takes the btrfs_*_libs definitions above and
# turns them into a list of libraries to link against if they exist
#
# For static variants, use an extra $(subst) to get rid of the ".static"
# from the target name before translating to list of libs

btrfs-%.static: $(static_objects) btrfs-%.static.o $(static_libbtrfs_objects)
	@echo "    [LD]     $@"
	$(Q)$(CC) $(STATIC_CFLAGS) -o $@ $@.o $(static_objects) \
		$(static_libbtrfs_objects) $(STATIC_LDFLAGS) $(STATIC_LIBS) \
		$($(subst -,_,$(subst .static,,$@)-libs))

btrfs-%: $(objects) $(libs) btrfs-%.o
	@echo "    [LD]     $@"
	$(Q)$(CC) $(CFLAGS) -o $@ $(objects) $@.o $(LDFLAGS) $(LIBS) $($(subst -,_,$@-libs))

btrfs: $(objects) btrfs.o help.o $(cmds_objects) $(libs)
	@echo "    [LD]     $@"
	$(Q)$(CC) $(CFLAGS) -o btrfs btrfs.o help.o $(cmds_objects) \
		$(objects) $(LDFLAGS) $(LIBS) -lpthread

btrfs.static: $(static_objects) btrfs.static.o help.static.o $(static_cmds_objects) $(static_libbtrfs_objects)
	@echo "    [LD]     $@"
	$(Q)$(CC) $(STATIC_CFLAGS) -o btrfs.static btrfs.static.o help.static.o $(static_cmds_objects) \
		$(static_objects) $(static_libbtrfs_objects) $(STATIC_LDFLAGS) $(STATIC_LIBS)

# For backward compatibility, 'btrfs' changes behaviour to fsck if it's named 'btrfsck'
btrfsck: btrfs
	@echo "    [LN]     $@"
	$(Q)$(LN) -f btrfs btrfsck

mkfs.btrfs: $(objects) $(libs) mkfs.o
	@echo "    [LD]     $@"
	$(Q)$(CC) $(CFLAGS) -o mkfs.btrfs $(objects) mkfs.o $(LDFLAGS) $(LIBS)

mkfs.btrfs.static: $(static_objects) mkfs.static.o $(static_libbtrfs_objects)
	@echo "    [LD]     $@"
	$(Q)$(CC) $(STATIC_CFLAGS) -o mkfs.btrfs.static mkfs.static.o $(static_objects) \
		$(static_libbtrfs_objects) $(STATIC_LDFLAGS) $(STATIC_LIBS)

btrfstune: $(objects) $(libs) btrfstune.o
	@echo "    [LD]     $@"
	$(Q)$(CC) $(CFLAGS) -o btrfstune $(objects) btrfstune.o $(LDFLAGS) $(LIBS)

dir-test: $(objects) $(libs) dir-test.o
	@echo "    [LD]     $@"
	$(Q)$(CC) $(CFLAGS) -o dir-test $(objects) dir-test.o $(LDFLAGS) $(LIBS)

quick-test: $(objects) $(libs) quick-test.o
	@echo "    [LD]     $@"
	$(Q)$(CC) $(CFLAGS) -o quick-test $(objects) quick-test.o $(LDFLAGS) $(LIBS)

ioctl-test: $(objects) $(libs) ioctl-test.o
	@echo "    [LD]     $@"
	$(Q)$(CC) $(CFLAGS) -o ioctl-test $(objects) ioctl-test.o $(LDFLAGS) $(LIBS)

send-test: $(objects) $(libs) send-test.o
	@echo "    [LD]     $@"
	$(Q)$(CC) $(CFLAGS) -o send-test $(objects) send-test.o $(LDFLAGS) $(LIBS) -lpthread

manpages:
	$(Q)$(MAKE) $(MAKEOPTS) -C man

clean: $(CLEANDIRS)
	@echo "Cleaning"
	$(Q)rm -f $(progs) cscope.out *.o *.o.d btrfs-convert btrfs-image btrfs-select-super \
	      btrfs-zero-log btrfstune dir-test ioctl-test quick-test send-test btrfsck \
	      btrfs.static mkfs.btrfs.static btrfs-calc-size \
	      version.h $(check_defs) \
	      $(libs) $(lib_links)

$(CLEANDIRS):
	@echo "Cleaning $(patsubst clean-%,%,$@)"
	$(Q)$(MAKE) $(MAKEOPTS) -C $(patsubst clean-%,%,$@) clean

install: $(libs) $(progs) $(INSTALLDIRS)
	$(INSTALL) -m755 -d $(DESTDIR)$(bindir)
	$(INSTALL) $(progs) $(DESTDIR)$(bindir)
	# btrfsck is a link to btrfs in the src tree, make it so for installed file as well
	$(LN) -f $(DESTDIR)$(bindir)/btrfs $(DESTDIR)$(bindir)/btrfsck
	$(INSTALL) -m755 -d $(DESTDIR)$(libdir)
	$(INSTALL) $(libs) $(DESTDIR)$(libdir)
	cp -a $(lib_links) $(DESTDIR)$(libdir)
	$(INSTALL) -m755 -d $(DESTDIR)$(incdir)
	$(INSTALL) -m644 $(headers) $(DESTDIR)$(incdir)

$(INSTALLDIRS):
	@echo "Making install in $(patsubst install-%,%,$@)"
	$(Q)$(MAKE) $(MAKEOPTS) -C $(patsubst install-%,%,$@) install

ifneq ($(MAKECMDGOALS),clean)
-include $(objects:.o=.o.d) $(cmd-objects:.o=.o.d) $(subst .btrfs,, $(filter-out btrfsck.o.d, $(progs:=.o.d)))
endif

=== debian/changelog ===
btrfs-tools (3.12-1ubuntu0.2) trusty; urgency=medium

  * Cherry-pick upstream fix loop device mount checks
    (LP: #1735046)

 -- Ryan Harper <ryan.harper@canonical.com>  Wed, 29 Nov 2017 13:44:30 -0600

btrfs-tools (3.12-1ubuntu0.1) trusty; urgency=high

  * Cherry-pick upstream fix for btrfsck tool to work on non-4k sectorsize
    filesystems, e.g. on ppc64el. (LP: #1438032)

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 11 Dec 2015 13:28:33 +0000

btrfs-tools (3.12-1) unstable; urgency=low

  [ Julien Muchembled ]
  * New upstream release. (Closes: #732075, #732533)
  * Drop patches merged upstream:
    - 07-manpage2.patch
    - 10-soname.patch
    - Btrfs-progs-fix-wrong-arg-sb_bytenr-for-btrfs_scan_fs_devices.patch
  * Refresh patches. (Closes: #719072)

  [ Dimitri John Ledkov ]
  * Add watch file.
  * Bump standards version to 3.9.5.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 01 Jan 2014 01:52:43 +0000

btrfs-tools (0.19+20130705-3) unstable; urgency=low

  * Import patch by Shilong Wang to resolve btrfs-convert (Closes:
    #724265) (LP: #1228302)

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Fri, 18 Oct 2013 23:47:16 +0100

btrfs-tools (0.19+20130705-2) unstable; urgency=low

  * Copy btrfs-zero-log into initramfs, useful for recovering (Closes: #721857)

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Mon, 16 Sep 2013 14:54:54 +0100

btrfs-tools (0.19+20130705-1) unstable; urgency=low

  * New upstream snapshot. (Closes: #720932)
  * Refresh patches.
  * btrfsctl is gone, and calc-size is prefixed with btrfs- upstream now.
  * Enable verbose build-log.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Mon, 26 Aug 2013 19:14:51 +0100

btrfs-tools (0.19+20130315-5) unstable; urgency=low

  * Provide "proper" fsck.btrfs, similar in spirit to fsck.xfs, that
    redirects users to use `btrfs check` and `btrfs restore` and exits
    with 0. (Closes: #715242) (Closes: #716989)
    Ideally, all btrfs mount points should be specified with fs_passno 0
    in fstab. If fstab is migrated to that, I'd want to consider dropping
    fsck.btrfs wrapper.

 -- Dmitrijs Ledkovs <xnox@debian.org>  Wed, 31 Jul 2013 14:52:17 +0100

btrfs-tools (0.19+20130315-4) unstable; urgency=low

  * Drop grub.d hacks, as initscripts correctly skips btrfs volumes for
    now. See bug #701956. And force remove hack on upgrade.
  * Conditionally include fsck.btrfs, if there is no generic fsck hook (Closes: 717867)
  * Install libraries in a multi-arch location. (Closes: #717868)
  * Drop dh_builddeb compression override to xz, use dpkg default instead,
    which is xz now anyway.

 -- Dmitrijs Ledkovs <xnox@debian.org>  Mon, 29 Jul 2013 14:51:19 +0100

btrfs-tools (0.19+20130315-3) unstable; urgency=low

  * New maintainer (Closes: #717564)
    - Thanks a lot to Luk and Daniel for previous
      maintainership. Co-maintainance is welcome!
  * Include fsck.btrfs in the initramfs
  * Use correct compiler, when cross-compiling
  * Default to act like fsck. (Closes: #712078)
  * Apply a gross hack to set fastboot for grub, if root is on btrfs
    because of bug 701936. One still needs to manually run update-grub.

 -- Dmitrijs Ledkovs <xnox@debian.org>  Tue, 23 Jul 2013 16:12:29 +0100

btrfs-tools (0.19+20130315-2) unstable; urgency=low

  * Fix unaligned access issue thanks to Holger Fischer.

 -- Luk Claes <luk@debian.org>  Mon, 20 May 2013 11:01:16 +0200

btrfs-tools (0.19+20130315-1) experimental; urgency=low

  * New upstream version.
    - Drop 01-labels.patch
    - Update patches
    - Drop 05-gzip.patch
    - Drop 06-armel.patch
    - Drop 08-fsck.patch
    - Drop 10-loop.patch
  * Add build dependency on libblkid-dev and liblzo2-dev.
  * Add lintian overrides as it does not make sense to split this
    small a package.
  * Set soname in 10-soname.patch.
  * Uploading to experimental as the unaligned access issue still
    needs to be fixed.

 -- Luk Claes <luk@debian.org>  Tue, 14 May 2013 15:23:45 +0200

btrfs-tools (0.19+20130131-3+really20121004-1) unstable; urgency=low

  * Taking over maintenance with maintainer's consent.
  * Reverting to previous upstream (Closes: #701936).

 -- Luk Claes <luk@debian.org>  Sun, 10 Mar 2013 22:28:39 +0100

btrfs-tools (0.19+20130131-3) unstable; urgency=low

  * Also ignoring fsck options -y, -C, and -V in btrfs check.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Fri, 08 Mar 2013 13:31:09 +0100

btrfs-tools (0.19+20130131-2) unstable; urgency=low

  * Replacing fsck.btrfs with wrapper arround 'btrfs check' to avoid
    different behaviour based on the filename btrfs is copied to (Closes:
    #701776).

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Wed, 27 Feb 2013 18:36:05 +0100

btrfs-tools (0.19+20130131-1) unstable; urgency=low

  * Merging upstream version 0.19+20130131.
  * Updating copyright file for new upstream version.
  * Updating years in copyright file.
  * Prefixing patches with four digits.
  * Trimming diff headers in patches.
  * Dropping dpkg-source compression levels.
  * Moving udev rules from 60-btrfs.rules to 70-btrfs.rules (Closes:
    #701642).
  * Dropping lables.patch, included upstream.
  * Rediffing manpage.patch.
  * Rediffing linker.patch.
  * Dropping gzip.patch, not needed anymore.
  * Dropping armel.patch, included upstream.
  * Rediffing manpage2.patch.
  * Dropping fsck.patch, not needed anymore.
  * Rediffing unaligned-memaccess.patch.
  * Dropping loop.patch, included upstream.
  * Renumbering patches.
  * Adding libblkid-dev to build-depends.
  * Including show-blocks.
  * Including bcp.
  * Adding suggests to python.
  * Adding lintian overrides.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Tue, 26 Feb 2013 12:12:39 +0100

btrfs-tools (0.19+20121004-2) unstable; urgency=low

  * Adding dpkg-source local options.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Tue, 11 Dec 2012 21:17:43 +0100

=== debian/control ===
Source: btrfs-tools
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Dimitri John Ledkov <xnox@debian.org>
Build-Depends: debhelper (>= 9),
               e2fslibs-dev,
               libacl1-dev,
               libblkid-dev,
               liblzo2-dev,
               uuid-dev,
               zlib1g-dev
Standards-Version: 3.9.5
Homepage: http://btrfs.wiki.kernel.org/

Package: btrfs-tools
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Checksumming Copy on Write Filesystem utilities
 Btrfs is a new copy on write filesystem for Linux aimed at implementing
 advanced features while focusing on fault tolerance, repair and easy
 administration.
 .
 This package contains utilities (mkfs, fsck) used to work with btrfs
 and an utility (btrfs-convert) to make a btrfs filesystem from an ext3.

Package: btrfs-tools-udeb
Package-Type: udeb
Section: debian-installer
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Checksumming Copy on Write Filesystem utilities (udeb)

Package: btrfs-tools-dbg
Section: debug
Priority: extra
Architecture: linux-any
Depends: btrfs-tools (= ${binary:Version}), ${misc:Depends}
Description: Checksumming Copy on Write Filesystem utilities (debug)
 Btrfs is a new copy on write filesystem for Linux aimed at implementing
 advanced features while focusing on fault tolerance, repair and easy
 administration.
 .
 This package contains the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  CC := $(DEB_HOST_GNU_TYPE)-gcc
else
  CC := gcc
endif

SHELL := sh -e

CFLAGS := $(shell dpkg-buildflags --get CFLAGS)
CFLAGS := $(patsubst -O2,-Os,$(CFLAGS))

%:
	dh ${@}

override_dh_auto_build:
	dh_auto_build -- all btrfs-select-super btrfs-calc-size CFLAGS="$(CFLAGS)" CC="$(CC)" BUILD_VERBOSE=1

override_dh_auto_install:
	dh_auto_install -- DESTDIR=$(CURDIR)/debian/btrfs-tools prefix=/usr bindir=/sbin mandir=/usr/share/man libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

	# Fixing 'manpage-not-compressed-with-max-compression'
	for _MANPAGE in $(CURDIR)/debian/btrfs-tools/usr/share/man/*/*.gz; \
	do \
		cd $$(dirname $${_MANPAGE}); \
		gunzip $$(basename $${_MANPAGE}); \
	done

	# Adding udev integration
	install -D -m 0644 debian/local/btrfs.udev debian/btrfs-tools/lib/udev/rules.d/70-btrfs.rules
	install -D -m 0644 debian/local/btrfs-lvm.udev debian/btrfs-tools/lib/udev/rules.d/80-btrfs-lvm.rules

	# Adding initramfs-tools integration
	install -D -m 0755 debian/local/btrfs.hook debian/btrfs-tools/usr/share/initramfs-tools/hooks/btrfs
	install -D -m 0755 debian/local/btrfs.local-premount debian/btrfs-tools/usr/share/initramfs-tools/scripts/local-premount/btrfs

override_dh_strip:
	dh_strip --dbg-package=btrfs-tools-dbg

# distclean target does not exist and make would waste time generating
# dependency files and version.h before failing. debhelper < 9.20130624
# would even think distclean exists because something is printed.
override_dh_auto_clean:
	make clean

=== debian/watch ===
version=3
https://www.kernel.org/pub/linux/kernel/people/mason/btrfs-progs/btrfs-progs-v(.+)\.tar\.xz

## btrfs-tools 3.17

=== Makefile ===
--- 
+++ 
@@ -5,21 +5,23 @@
 LN = ln
 AR = ar
 AM_CFLAGS = -Wall -D_FILE_OFFSET_BITS=64 -DBTRFS_FLAT_INCLUDES -fno-strict-aliasing -fPIC
-CFLAGS = -g -O1 -fno-strict-aliasing
+CFLAGS = -g -O1 -fno-strict-aliasing -rdynamic
 objects = ctree.o disk-io.o radix-tree.o extent-tree.o print-tree.o \
 	  root-tree.o dir-item.o file-item.o inode-item.o inode-map.o \
 	  extent-cache.o extent_io.o volumes.o utils.o repair.o \
-	  qgroup.o raid6.o free-space-cache.o list_sort.o
+	  qgroup.o raid6.o free-space-cache.o list_sort.o props.o \
+	  ulist.o qgroup-verify.o backref.o rbtree-utils.o
 cmds_objects = cmds-subvolume.o cmds-filesystem.o cmds-device.o cmds-scrub.o \
 	       cmds-inspect.o cmds-balance.o cmds-send.o cmds-receive.o \
 	       cmds-quota.o cmds-qgroup.o cmds-replace.o cmds-check.o \
-	       cmds-restore.o cmds-rescue.o chunk-recover.o super-recover.o
+	       cmds-restore.o cmds-rescue.o chunk-recover.o super-recover.o \
+	       cmds-property.o
 libbtrfs_objects = send-stream.o send-utils.o rbtree.o btrfs-list.o crc32c.o \
-		   uuid-tree.o
+		   uuid-tree.o utils-lib.o
 libbtrfs_headers = send-stream.h send-utils.h send.h rbtree.h btrfs-list.h \
 	       crc32c.h list.h kerncompat.h radix-tree.h extent-cache.h \
-	       extent_io.h ioctl.h ctree.h btrfsck.h
-TESTS = fsck-tests.sh
+	       extent_io.h ioctl.h ctree.h btrfsck.h version.h
+TESTS = fsck-tests.sh convert-tests.sh
 
 INSTALL = install
 prefix ?= /usr/local
@@ -48,16 +50,27 @@
 	btrfs btrfs-map-logical btrfs-image btrfs-zero-log btrfs-convert \
 	btrfs-find-root btrfstune btrfs-show-super
 
+progs_static = $(foreach p,$(progs),$(p).static)
+
 # external libs required by various binaries; for btrfs-foo,
 # specify btrfs_foo_libs = <list of libs>; see $($(subst...)) rules below
 btrfs_convert_libs = -lext2fs -lcom_err
 btrfs_image_libs = -lpthread
-btrfs_fragment_libs = -lgd -lpng -ljpeg -lfreetype
-
-SUBDIRS = man
+btrfs_fragments_libs = -lgd -lpng -ljpeg -lfreetype
+
+SUBDIRS =
 BUILDDIRS = $(patsubst %,build-%,$(SUBDIRS))
 INSTALLDIRS = $(patsubst %,install-%,$(SUBDIRS))
 CLEANDIRS = $(patsubst %,clean-%,$(SUBDIRS))
+
+ifeq ($(DISABLE_BACKTRACE),1)
+AM_CFLAGS += -DBTRFS_DISABLE_BACKTRACE
+endif
+
+ifneq ($(DISABLE_DOCUMENTATION),1)
+BUILDDIRS += build-Documentation
+INSTALLDIRS += install-Documentation
+endif
 
 .PHONY: $(SUBDIRS)
 .PHONY: $(BUILDDIRS)
@@ -118,7 +131,7 @@
 	@echo "    [CC]     $@"
 	$(Q)$(CC) $(AM_CFLAGS) $(STATIC_CFLAGS) -c $< -o $@
 
-all: $(progs) manpages $(BUILDDIRS)
+all: $(progs) $(BUILDDIRS)
 $(SUBDIRS): $(BUILDDIRS)
 $(BUILDDIRS):
 	@echo "Making all in $(patsubst build-%,%,$@)"
@@ -134,7 +147,7 @@
 # NOTE: For static compiles, you need to have all the required libs
 # 	static equivalent available
 #
-static: btrfs.static mkfs.btrfs.static btrfs-find-root.static
+static: $(progs_static)
 
 version.h:
 	@echo "    [SH]     $@"
@@ -167,8 +180,8 @@
 btrfs-%.static: $(static_objects) btrfs-%.static.o $(static_libbtrfs_objects)
 	@echo "    [LD]     $@"
 	$(Q)$(CC) $(STATIC_CFLAGS) -o $@ $@.o $(static_objects) \
-		$(static_libbtrfs_objects) $(STATIC_LDFLAGS) $(STATIC_LIBS) \
-		$($(subst -,_,$(subst .static,,$@)-libs))
+		$(static_libbtrfs_objects) $(STATIC_LDFLAGS) \
+		$($(subst -,_,$(subst .static,,$@)-libs)) $(STATIC_LIBS)
 
 btrfs-%: $(objects) $(libs) btrfs-%.o
 	@echo "    [LD]     $@"
@@ -189,6 +202,10 @@
 	@echo "    [LN]     $@"
 	$(Q)$(LN) -f btrfs btrfsck
 
+btrfsck.static: btrfs.static
+	@echo "    [LN]     $@"
+	$(Q)$(LN) -f $^ $@
+
 mkfs.btrfs: $(objects) $(libs) mkfs.o
 	@echo "    [LD]     $@"
 	$(Q)$(CC) $(CFLAGS) -o mkfs.btrfs $(objects) mkfs.o $(LDFLAGS) $(LIBS)
@@ -202,6 +219,11 @@
 	@echo "    [LD]     $@"
 	$(Q)$(CC) $(CFLAGS) -o btrfstune $(objects) btrfstune.o $(LDFLAGS) $(LIBS)
 
+btrfstune.static: $(static_objects) btrfstune.static.o $(static_libbtrfs_objects)
+	@echo "    [LD]     $@"
+	$(Q)$(CC) $(STATIC_CFLAGS) -o $@ btrfstune.static.o $(static_objects) \
+		$(static_libbtrfs_objects) $(STATIC_LDFLAGS) $(STATIC_LIBS)
+
 dir-test: $(objects) $(libs) dir-test.o
 	@echo "    [LD]     $@"
 	$(Q)$(CC) $(CFLAGS) -o dir-test $(objects) dir-test.o $(LDFLAGS) $(LIBS)
@@ -219,7 +241,9 @@
 	$(Q)$(CC) $(CFLAGS) -o send-test $(objects) send-test.o $(LDFLAGS) $(LIBS) -lpthread
 
 manpages:
-	$(Q)$(MAKE) $(MAKEOPTS) -C man
+	$(Q)$(MAKE) $(MAKEOPTS) -C Documentation
+
+clean-all: clean-doc clean
 
 clean: $(CLEANDIRS)
 	@echo "Cleaning"
@@ -229,6 +253,10 @@
 	      version.h $(check_defs) \
 	      $(libs) $(lib_links)
 
+clean-doc:
+	@echo "Cleaning Documentation"
+	$(Q)$(MAKE) $(MAKEOPTS) -C Documentation clean
+
 $(CLEANDIRS):
 	@echo "Cleaning $(patsubst clean-%,%,$@)"
 	$(Q)$(MAKE) $(MAKEOPTS) -C $(patsubst clean-%,%,$@) clean
@@ -236,6 +264,7 @@
 install: $(libs) $(progs) $(INSTALLDIRS)
 	$(INSTALL) -m755 -d $(DESTDIR)$(bindir)
 	$(INSTALL) $(progs) $(DESTDIR)$(bindir)
+	$(INSTALL) fsck.btrfs $(DESTDIR)$(bindir)
 	# btrfsck is a link to btrfs in the src tree, make it so for installed file as well
 	$(LN) -f $(DESTDIR)$(bindir)/btrfs $(DESTDIR)$(bindir)/btrfsck
 	$(INSTALL) -m755 -d $(DESTDIR)$(libdir)
@@ -244,10 +273,22 @@
 	$(INSTALL) -m755 -d $(DESTDIR)$(incdir)
 	$(INSTALL) -m644 $(headers) $(DESTDIR)$(incdir)
 
+install-static: $(progs_static) $(INSTALLDIRS)
+	for p in $(progs_static) ; do \
+		$(INSTALL) -D -m755 $$p $(DESTDIR)$(bindir)/`basename $$p .static` ; \
+	done
+
 $(INSTALLDIRS):
 	@echo "Making install in $(patsubst install-%,%,$@)"
 	$(Q)$(MAKE) $(MAKEOPTS) -C $(patsubst install-%,%,$@) install
 
+uninstall:
+	$(Q)$(MAKE) $(MAKEOPTS) -C Documentation uninstall
+	cd $(DESTDIR)$(incdir); rm -f $(headers)
+	rmdir -p --ignore-fail-on-non-empty $(DESTDIR)$(incdir)
+	cd $(DESTDIR)$(libdir); rm -f $(lib_links) $(libs)
+	cd $(DESTDIR)$(bindir); rm -f btrfsck fsck.btrfs $(progs)
+
 ifneq ($(MAKECMDGOALS),clean)
 -include $(objects:.o=.o.d) $(cmd-objects:.o=.o.d) $(subst .btrfs,, $(filter-out btrfsck.o.d, $(progs:=.o.d)))
 endif

=== debian/changelog ===
btrfs-tools (3.17-1.1~bpo70+1) wheezy-backports; urgency=medium

  * Rebuild for wheezy-backports.

 -- Aron Xu <aron@debian.org>  Sun, 21 Jun 2015 06:28:30 +0800

btrfs-tools (3.17-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add 0002-Fix-linking-with-libbtrfs.patch from upstream, to properly
    export all the previously exported API (Closes: #768746)
  * Add 0003-Make-headers-C++-compatible.patch from upstream, making the
    new headers C++-compatible.

 -- Nicolas Dandrimont <olasd@debian.org>  Sat, 22 Nov 2014 14:52:06 +0100

btrfs-tools (3.17-1) unstable; urgency=medium

  * New upstream release.

 -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Thu, 23 Oct 2014 22:04:07 +0100

btrfs-tools (3.16.2-1) unstable; urgency=medium

  * New upstream release.
  * Drop patches (not needed, or upstremed), but unaligned memory access.
  * Update upstream location in uscan, to pull release by kdave.
  * Use upstream fsck.btrfs script.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sat, 11 Oct 2014 16:54:05 +0100

btrfs-tools (3.16-1) unstable; urgency=medium

  * New upstream release.
  * Add asciidoc & xmlto build dependencies.
  * Disable test-suites for now, should be run as autopkgtests.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sun, 21 Sep 2014 02:05:14 +0100

btrfs-tools (3.14.1-1) unstable; urgency=medium

  * New upstream release.
  * Switch to git-dpm.
  * Rebase and cleanup patches.

 -- Dimitri John Ledkov <xnox@debian.org>  Sat, 19 Apr 2014 12:12:11 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,16 @@
 Source: btrfs-tools
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Dimitri John Ledkov <xnox@debian.org>
+Maintainer: Dimitri John Ledkov <xnox@debian.org>
 Build-Depends: debhelper (>= 9),
                e2fslibs-dev,
                libacl1-dev,
                libblkid-dev,
                liblzo2-dev,
                uuid-dev,
-               zlib1g-dev
+               zlib1g-dev,
+               asciidoc,
+               xmlto,
 Standards-Version: 3.9.5
 Homepage: http://btrfs.wiki.kernel.org/

## btrfs-tools 4.0

=== debian/changelog ===
btrfs-tools (4.0-2~nd90+1+nd17.04+1) zesty; urgency=medium

  * Backported for zesty.

 -- unamed <unknown>  Mon, 08 May 2017 00:29:23 -0400

btrfs-tools (4.0-2~nd90+1) stretch; urgency=low

  * Backported for stretch.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Thu, 25 Jun 2015 11:55:27 -0400

btrfs-tools (4.0-2) unstable; urgency=medium

  * Adjust initramfs hooks and udev rules for move of all binaries to
    /bin. (Closes: #784234)

 -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Mon, 04 May 2015 18:51:07 +0100

btrfs-tools (4.0-1) unstable; urgency=medium

  * New upstream release.
  * Drop all patches.
  * Experiment with dropping udev rules, in favour of systemd-udev builtin
    integration. (Closes: #772744)
  * Move all binaries to /bin (Closes: #770806)
  * Switch to autoconf based build system.

 -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Sun, 18 Jan 2015 00:14:20 +0000

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,11 @@
 Source: btrfs-tools
 Section: admin
 Priority: optional
-Maintainer: Dimitri John Ledkov <xnox@debian.org>
+Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
+X-Original-Maintainer: Dimitri John Ledkov <xnox@debian.org>
 Build-Depends: debhelper (>= 9),
                e2fslibs-dev,
+               pkg-config,
                libacl1-dev,
                libblkid-dev,
                liblzo2-dev,
@@ -16,7 +18,7 @@
 
 Package: btrfs-tools
 Architecture: linux-any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: neurodebian-popularity-contest, ${misc:Depends}, ${shlibs:Depends}
 Description: Checksumming Copy on Write Filesystem utilities
  Btrfs is a new copy on write filesystem for Linux aimed at implementing
  advanced features while focusing on fault tolerance, repair and easy
@@ -29,14 +31,14 @@
 Package-Type: udeb
 Section: debian-installer
 Architecture: linux-any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: neurodebian-popularity-contest, ${misc:Depends}, ${shlibs:Depends}
 Description: Checksumming Copy on Write Filesystem utilities (udeb)
 
 Package: btrfs-tools-dbg
 Section: debug
 Priority: extra
 Architecture: linux-any
-Depends: btrfs-tools (= ${binary:Version}), ${misc:Depends}
+Depends: neurodebian-popularity-contest, btrfs-tools (= ${binary:Version}), ${misc:Depends}
 Description: Checksumming Copy on Write Filesystem utilities (debug)
  Btrfs is a new copy on write filesystem for Linux aimed at implementing
  advanced features while focusing on fault tolerance, repair and easy

## btrfs-tools 4.1.2

=== debian/changelog ===
btrfs-tools (4.1.2-1~nd80+1) jessie; urgency=medium

  * Backported for jessie.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Fri, 09 Oct 2015 23:57:14 -0400

btrfs-tools (4.1.2-1) unstable; urgency=medium

  * New upstream release.

 -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Sun, 30 Aug 2015 00:18:54 +0100

## btrfs-tools 4.4

=== debian/changelog ===
btrfs-tools (4.4-1ubuntu1.1) xenial; urgency=medium

  * Add `Provides: btrfs-progs` to btrfs-tools as a more common upstream
    name for the package, which started to be used by default in bionic
    and later. This helps users to install the btrfs utility irrespective
    if they use legacy or the futureproof name. LP: #1839500

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 08 Aug 2019 16:30:00 +0100

btrfs-tools (4.4-1ubuntu1) xenial; urgency=medium

  * debian/patches/09c052a8b4dcaa96fe5e6c28b12ce24729e827a4.patch:
    backport upstream commit to add new "quiet option" and prevent printing of
    messages on stderr (LP: #1694891)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 14 Jun 2017 19:48:16 +0200

btrfs-tools (4.4-1) unstable; urgency=medium

  * New upstream release.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 19 Jan 2016 19:03:41 +0000

btrfs-tools (4.3-1) unstable; urgency=medium

  * New upstream release.

 -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Sat, 07 Nov 2015 11:27:13 +0000

btrfs-tools (4.2.2-1) unstable; urgency=medium

  * New upstream release.

 -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Sat, 24 Oct 2015 00:09:28 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: btrfs-tools
 Section: admin
 Priority: optional
-Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
-X-Original-Maintainer: Dimitri John Ledkov <xnox@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Dimitri John Ledkov <xnox@debian.org>
 Build-Depends: debhelper (>= 9),
                e2fslibs-dev,
                pkg-config,
@@ -18,7 +18,8 @@
 
 Package: btrfs-tools
 Architecture: linux-any
-Depends: neurodebian-popularity-contest, ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Provides: btrfs-progs
 Description: Checksumming Copy on Write Filesystem utilities
  Btrfs is a new copy on write filesystem for Linux aimed at implementing
  advanced features while focusing on fault tolerance, repair and easy
@@ -31,14 +32,14 @@
 Package-Type: udeb
 Section: debian-installer
 Architecture: linux-any
-Depends: neurodebian-popularity-contest, ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Checksumming Copy on Write Filesystem utilities (udeb)
 
 Package: btrfs-tools-dbg
 Section: debug
 Priority: extra
 Architecture: linux-any
-Depends: neurodebian-popularity-contest, btrfs-tools (= ${binary:Version}), ${misc:Depends}
+Depends: btrfs-tools (= ${binary:Version}), ${misc:Depends}
 Description: Checksumming Copy on Write Filesystem utilities (debug)
  Btrfs is a new copy on write filesystem for Linux aimed at implementing
  advanced features while focusing on fault tolerance, repair and easy

=== debian/watch ===
version=3
https://www.kernel.org/pub/linux/kernel/people/kdave/btrfs-progs/btrfs-progs-v(.+)\.tar\.xz
